image: node

stages:
  - test
  - build
  - deploy

before_script:    #este é global e sera aplicado em todos dos jobs
  - whoami
  - pwd

test site:
  stage: test
  before_script:
    - npm install -g broken-link-checker@^0.7.8 wait-on@^5.2.1    #as versões foram adicionadas @^0.7.8 e @^5.2.1
  script:
    - cd website
    - yarn install && yarn build
    - npm run serve &
    - wait-on http://localhost:3000 --timeout 30000
    - blc --recursive --exclude-external http://localhost:3000

check vulnerability:
  stage: test
  script:
    - cd website && npm install -g snyk
    - snyk monitor

build site:
  stage: build
  cache:
    key: site-package
    policy: push
    paths:
      - ./website/build
  artifacts:
    name: "$CI_JOB_NAME-$CI_COMMIT_REF_NAME"
    when: on_failure    #irá disponibilizar em caso de falha do job
    expire_in: 2h20min
    paths:
      - ./website/build
  script:
    - cd website
    - npm version
    - yarn install
    - yarn build

deploy staging:
  stage: deploy
  variables:
    CNAME: staging-pdajgs.surge.sh
    GIT_STRATEGY: none
  cache:
    key: site-package
    paths:
      - ./website/build   #para realizar o pull o paths deve ser adicionado, para que não ocorra o erro... pipeline id '#239732538'
    policy: pull
  before_script:    #este irá sobrescrever o global
    - npm install -g surge@^0.21.7    #a versão foi adicionada, a saber @^0.21.7
  script:
    - surge --project ./website/build --domain ${CNAME}
  after_script:   #executa mesmo se os scripts anteriores falharem
    - whoami
  environment:
    name: develop
    url: http://${CNAME}
  only:   #só irá rodar na branch develop
    - develop

deploy release:
  stage: deploy
  variables:
    CNAME: $CI_COMMIT_REF_SLUG.pdajgs.surge.sh
    GIT_STRATEGY: none
  cache:
    key: site-package
    paths:
      - ./website/build
    policy: pull
  before_script:
    - npm install -g surge@^0.21.7
  script:
    - surge --project ./website/build --domain ${CNAME}
  after_script:
    - whoami
  environment:
    name: review/$CI_COMMIT_REF_SLUG
    url: http://${CNAME}
    on_stop: turnoff
  only:
    - /^release-.*$/

turnoff:
  stage: deploy
  variables:
    CNAME: $CI_COMMIT_REF_SLUG.pdajgs.surge.sh
    GIT_STRATEGY: none
  before_script:
    - npm install -g surge@^0.21.7
  script:
    - surge teardown ${CNAME}
  when: manual
  environment:
    name: review/$CI_COMMIT_REF_SLUG
    url: http://${CNAME}
    action: stop
  only:
    - /^release-.*$/

deploy prod:
  stage: deploy
  variables:
    CNAME: prod-pdajgs.surge.sh
    GIT_STRATEGY: none
  cache:
    key: site-package
    paths:
      - ./website/build   #para realizar o pull o paths deve ser adicionado, para que não ocorra o erro... pipeline id '#239732538'
    policy: pull
  before_script:    #este irá sobrescrever o global
    - npm install -g surge@^0.21.7    #a versão foi adicionada, a saber @^0.21.7
  script:
    - surge --project ./website/build --domain ${CNAME}
  after_script:   #executa mesmo se os scripts anteriores falharem
    - whoami
  environment:
    name: production
    url: http://${CNAME}
  only:   #só irá rodar na branch develop
    - master